

CREATE TABLE SEQUENCES(
SEQUENCE_ID int NOT NULL CONSTRAINT PK_SEQUENCES1 PRIMARY KEY,
NAME varchar(100) NULL,
SCHEMA varchar(100) NULL,
INC numeric NULL,
MIN_VAL numeric NULL,
MAX_VAL numeric NULL,
CACHE int NULL,
CYCLE_FLAG bit NULL,
ORDER_FLAG bit NULL,
FLUSH_FLAG bit NULL)
;


CREATE TABLE USERS(
NAME varchar(255) NOT NULL CONSTRAINT PK_USERS1 PRIMARY KEY,
PASSWORD binary(16) NULL,
CREATED_DATE datetime NULL)
;


CREATE TABLE TABLES(
TABLE_ID int NOT NULL CONSTRAINT PK_TABLES1 PRIMARY KEY,
TABLE_NAME varchar(255) NOT NULL,
USER_NAME varchar(255) NOT NULL,
CREATED_DATE datetime NULL,
CONSTRAINT UC_TABLES1 UNIQUE(TABLE_NAME))
;


CREATE TABLE INDEXES(
INDEX_ID int NOT NULL CONSTRAINT PK_INDEXES1 PRIMARY KEY,
INDEX_NAME varchar(255) NOT NULL,
TABLE_ID int NOT NULL,
UNIQUE_FLAG bit NOT NULL)
;


CREATE TABLE INDEX_COLUMNS(
INDEX_COLUMN_ID int NOT NULL CONSTRAINT PK_INDEX_COLUMNS1 PRIMARY KEY,
INDEX_ID int NOT NULL,
POSITION smallint NULL,
COLUMN_NAME varchar(100) NULL)
;


CREATE TABLE COLUMNS(
COLUMN_ID int NOT NULL CONSTRAINT PK_COLUMNS1 PRIMARY KEY,
POSITION int NULL,
NAME varchar(255) NOT NULL,
TYPE int NULL,
SIZE int NULL,
PRECISION int NULL,
NULLABLE_FLAG bit NOT NULL,
TABLE_ID int NOT NULL)
;


CREATE TABLE FK_CONSTRAINTS(
FK_CONSTRAINT_ID int NOT NULL CONSTRAINT PK_FK_CONSTRAINTS1 PRIMARY KEY)
;


CREATE TABLE CHECK_CONSTRAINTS(
CHECK_CONSTRAINT_ID int NOT NULL CONSTRAINT PK_CHECK_CONSTRAINTS1 PRIMARY KEY)
;


CREATE TABLE PK_FIELDS(
PK_FIELD_ID int NOT NULL CONSTRAINT PK_PK_FIELDS1 PRIMARY KEY,
FIELD_NAME varchar(255) NOT NULL,
POSITION int NOT NULL,
TABLE_ID int NULL)
;






ALTER TABLE TABLES
ADD CONSTRAINT FK_TABLES_1 
FOREIGN KEY (USER_NAME) REFERENCES USERS (NAME)
;


ALTER TABLE INDEXES
ADD CONSTRAINT FK_INDEXES_1 
FOREIGN KEY (TABLE_ID) REFERENCES TABLES (TABLE_ID)
;


ALTER TABLE INDEX_COLUMNS
ADD CONSTRAINT FK_INDEX_COLUMNS_1 
FOREIGN KEY (INDEX_ID) REFERENCES INDEXES (INDEX_ID)
;


ALTER TABLE COLUMNS
ADD CONSTRAINT FK_COLUMNS_1 
FOREIGN KEY (TABLE_ID) REFERENCES TABLES (TABLE_ID)
;




ALTER TABLE PK_FIELDS
ADD CONSTRAINT FK_PK_FIELDS_1 
FOREIGN KEY (TABLE_ID) REFERENCES TABLES (TABLE_ID)
;

