/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Dec 6, 2001
 * Time: 7:38:56 PM
 * To change template for new interface use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.api;

import freebase.engine.Transaction;
import freebase.lock.ValueLock;

import java.sql.SQLException;

/**
 * Represents a specific implementation of IndexCursor Storage.  It has
 * methods for accessing IndexCursors
 */
public interface IndexStorage extends LogEntryProcessor {
    /**
     * if readWriteMode is false, it is read only.
     * if it is true, then it is for both.  I have no idea if this will ever
     * be used
     */
    IndexCursor getIndexCursor(Transaction t, boolean readWriteMode) throws SQLException;

    //  return cursor?
    //  drop

    int getIndexId();

    /**
     * get lock manager.
     * @return null if locks do not apply to this index.
     */
    ValueLock getLockManager();

    //  is this field alone sufficient to use this index?
    boolean canFindWith(String field);  // []

    //  is this field alone sufficient to use this index for scanning?
    boolean canScanWith(String field);  //  []

    void truncateIndex(Transaction t) throws SQLException;

    /**
     * Optional debugging method
     */
    void dumpContents();
}
