/**
 * Copyright 2004 JJ Furman
 */
package freebase.api;

import java.sql.SQLException;

/**
 * Implemented by TableTupleIterator and IndexScan.
 * TODO:  maybe make the names more explicit as lockRowPending etc
 *    Thus, the finalize lock would be makePendingLockPermanent -or- 
 */
public interface LockableTupleIterator extends TupleIterator {
    /**
     * Put a pending lock the current row.  This lock is a placeholder until we decided
     * if this row still qualifies to our condition.
     * @throws SQLException If the row has been deleted, will definitely throw a View Exception or can't serialize
     */
    void lockRow() throws SQLException;

    /**
     * release the pending lock
     * @throws SQLException
     */
    void unlockRow() throws SQLException;
}
