/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 12, 2001
 * Time: 8:33:02 PM
 * To change template for new interface use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.api;

import freebase.engine.Transaction;
import freebase.log.LogEntry;

import java.sql.SQLException;

/**
 * Anything that processes log entries, in forward and reverse.
 *
 * Possible better names:  LogEntryProcessor / Handler
 */
public interface LogEntryProcessor {
    public final static int REDO_ENTRY = 0;
    public final static int UNDO_ENTRY = 1;

    /**
     * applyMode will be one of the above
     * @param t the transaction object handling this.
     */
    void processLogEntry(int applyMode, long lsn, Transaction t, LogEntry logEntry)
            throws SQLException;
}
