/**
 * Copyright 2004 JJ Furman
 * Time: 6:33:37 PM
 */
package freebase.api;

import java.math.BigInteger;
import java.sql.SQLException;

/**
 * Storage for the next sequence value.
 */
public interface SequenceStorage extends LogEntryProcessor {
    /**
     * drop storage for this.  Journal a log entry and wait for completion.
     * @throws SQLException
     */
    //void drop() throws SQLException;

    int getSequenceId();

    /**
     * generally only called at load/recover time.
     * @return
     * @throws SQLException
     */
    BigInteger getValue() throws SQLException;

    /**
     * @param val
     * @throws SQLException
     */
    void setValue(BigInteger val, boolean flush) throws SQLException;
}
