/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Dec 6, 2001
 * Time: 7:37:01 PM
 * To change template for new interface use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.api;

import freebase.engine.Transaction;

import java.sql.SQLException;

/**
 * Represents a specific implementation of table storage data
 */
public interface TableStorage extends LogEntryProcessor {
    /**
     * Helpful for debugging
     */
    void setName(String name);

    int getTableId();

    /**
     * delete the storage associated with this table... now!
     */
    void dropTable();

    /**
     * Do it.  Make sure existing readers are still stable.  Null passed in currently means don't log, thus
     * only called on a redo
     */
    void truncateTable(Transaction t) throws SQLException;

    /**
     * Lock implementation may be storage sensitive, so it is here.
     * TODO:  probably will not continue to be like this.
     */
    TableLockManager getLockManager() throws SQLException;

    /**
     * Transaction is used to obtain a ConsistentView
     */
    TableCursor getTableCursor(Transaction t, boolean readWriteMode) throws SQLException;
}
