/*
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: Sep 10, 2001
 * Time: 9:42:47 PM
 * To change template for new interface use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.api;


import freebase.server.ExecutionPlan;

import java.sql.SQLException;

/**
 * Generally relation iterators start before the beginning.  Current design is that
 * no work gets done in the underlying source until the first "next" is called.
 * Probably would have been good to have a first() method, but the internal test is
 * fast.
 *
 * TODO:  maybe should go into plan or query
 */
public interface TupleIterator extends Tuple {
    /**
     * Puts the cursor for this iterator back before the first row, as it is
     * before the first next is called.  For now, this will do.  We may need
     * also/instead a pair of methods for recording the current position and
     * resetting it later.  At the begininning first is equivalent to next.
     */
    void reset() throws SQLException;

    /**
     * Step to next Relation.
     */
    boolean next() throws SQLException;

    //  testCondition, if needed, a base implementation can handle this.
    //  might make it faster to run.

    void close() throws SQLException;

    /**
     * Returns the Execution Plan for this Tuple Iterator.  Most implementations of
     * this will build it every time.
     */
    ExecutionPlan getExecutionPlan() throws SQLException;
}
