/**
 * Copyright 2004 JJ Furman
 * Time: 10:15:36 AM
 */
package freebase.api;

import freebase.util.Bool;

import java.math.BigInteger;
import java.sql.SQLException;

/**
 * Really a helper method.  Rather than making all TupleIterator implementation implement all
 * the hard types like string, int etc, just wrap the final on with this to make your life easier.
 */
public class TypedTupleIterator extends FilterTupleIterator {

    public TypedTupleIterator(TupleIterator source) {
        super(source);
    }

    /**********************************************************************************
     * additional helper methods
     */
    public int getInt(int pos) throws SQLException {
        return ((Number)getValue(pos)).intValue();
    }

    public String getString(int pos) throws SQLException {
        return (String)getValue(pos);
    }

    public boolean getBoolean(int pos) throws SQLException {
        return ((Bool)getValue(pos)).getValue();
    }

    public BigInteger getBigInteger(int pos) throws SQLException {
        return (BigInteger)getValue(pos);
    }
}
