package freebase.catalog;

import freebase.engine.Transaction;

import java.math.BigInteger;
import java.sql.SQLException;

/**
 * A wrapper class used to separate the sqlexpression from specific sequence
 * provider implementation.  This could just as easily be an interface.
 * NOTE:  these could be put into an API package of sorts
 */
public class SeqValueProvider {
    Transaction t;
    Sequence s;

    public SeqValueProvider(Transaction t, Sequence s) {
        this.t = t;
        this.s = s;
    }

    public BigInteger getNextValue() throws SQLException {
        return s.getNextValue(t);
    }

    public BigInteger getCurValue()  throws SQLException {
        return s.getCurValue(t);
    }
}
