package freebase.engine;

import freebase.store.EntityManager;


/**
 *  manages all outstanding cursors.  When they are returned it should
 *  assure that the system can do all proper work to migrate the system to the
 *  new low water mark
 *
 * NOTE:  though I still like all of the concepts, this is currently mothballed
 */
public class CursorManager {
    EntityManager entityManager;
    
    public CursorManager(EntityManager em) {
        entityManager = em;
    }
    
    /**
     *  TODO:  implement cursor recycling
     *  TODO:  decide on how parallelism will be managed by the cursors
     */
    public OldTableCursor getTableCursor(int entityId, boolean bGoingToWrite) {
        OldTableCursor tc = new OldTableCursor();
        
        tc.resetCursor(null, null, entityId, entityManager.getBufferPoolForEntity(entityId), bGoingToWrite);
        return tc;
    }
    
    
    /**
     *  here to allow the system to know about any outstanding scanners and such
     */
    public void disposeTableCursor(OldTableCursor tc) {
        tc.deCommission();
    }
}