/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 28, 2001
 * Time: 9:52:31 AM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.log.data;

import freebase.log.LogEntry;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * All subclasses of TableLogEntry get routed to tables.
 *
 * TODO:  possibly add storage area too, for support for multiple StorageManagers
 */
public class TableLogEntry extends LogEntry {
    private int tableId;

    /**
     *
     */
    protected TableLogEntry() {}

    public TableLogEntry(int tableId) {
        this.tableId = tableId;
    }

    public int getTableId() {
        return tableId;
    }

    /******
     * IO related methods
     */

    public int getSize() {
        return 4;
    }

    public void readIn(DataInput in) throws IOException {
        tableId = in.readInt();
    }

    public void writeOut(DataOutput out) throws IOException {
        out.writeInt(tableId);
    }
}
