/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Dec 30, 2001
 * Time: 6:09:12 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.log.index;

import freebase.log.LogEntry;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * Holds an entry for an index.  Subclass is MemoryIndexLogEntry (among others)
 */
public class IndexLogEntry extends LogEntry {
    private int indexId;

    public IndexLogEntry() { }

    public IndexLogEntry(int indexId) {
        this.indexId = indexId;
    }

    public int getIndexId() {
        return indexId;
    }

    public int getSize() {
        return 4;
    }

    public void readIn(DataInput in) throws IOException {
        indexId = in.readInt();
    }

    public void writeOut(DataOutput out) throws IOException {
        out.writeInt(indexId);
    }
}
