/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 13, 2001
 * Time: 7:47:55 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.log.tm;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

public class CommitLogEntry extends TMLogEntry {
    /**
     * Time that this transaction finished (in local time I presume)
     */
    long scn;

    /**
     * Called to construct it upon recovery
     */
    public CommitLogEntry() { }

    public CommitLogEntry(long finishTime) {
        this.scn = finishTime;
    }

    /**
     *  for now has no additional data
     */
    public int getSize() {
        return super.getSize() + 8;
    }

    public short getCode() {
        return COMMIT_TRANSACTION_LOG_CODE;
    }

    public String toString() {
        return "Commit Transaction scn:" + scn;
    }

    /**
     * Same as finish time.
     */
    public long getScn() {
        return scn;
    }

    /**
     * Do nothing
     */
    public void readIn(DataInput in) throws IOException {
        super.readIn(in);

        scn = in.readLong();
    }

    /**
     * Do nothing
     */
    public void writeOut(DataOutput out) throws IOException {
        super.writeOut(out);

        out.writeLong(scn);
    }
}
