/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 13, 2001
 * Time: 7:46:53 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.log.tm;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * Represents a rollback START operation.  All entries from the one just previous to this one
 * in the transaction all the way back to the toLSN should be rolled back.  This log message
 * does not represent the end of the transaction.  For that see Inactivate transaction.
 */
public class RollbackLogEntry extends TMLogEntry {
    /**
     * Should only be called when loading the entry from storage.
     */
    public RollbackLogEntry() {}

    public String toString() {
        return "Rollback Start";
    }

    /**
     * Used to have size + 8, but since there is no data I have removed it!!
     * Used to say have room for the LSN, but for some reason its in RollbackCompleteLogEntry now.  I don't
     * know what is right.
     */
    public int getSize() {
        return super.getSize(); // + 8;
    }

    public short getCode() {
        return ROLLBACK_LOG_CODE;
    }

    public void readIn(DataInput in) throws IOException {
        super.readIn(in);
    }

    public void writeOut(DataOutput out) throws IOException {
        super.writeOut(out);
    }
}
