/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 13, 2001
 * Time: 7:45:28 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.log.tm;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

/**
 * Savepoint is where to stop.
 */
public class SavepointLogEntry extends TMLogEntry {
    /**
     * for performing quicker scans through, but only used if
     * we can't keep them all in memory.  IE, for now not used
     */
    long lastSavepointLSN;

    /**
     * name of this savepoint.
     */
    String name;

    /**
     * Should only be called when loading the entry from storage.
     */
    public SavepointLogEntry() {}

    public SavepointLogEntry(String name) {
        this.name = name;
    }

    public void writeOut(DataOutput out) throws IOException {
        super.writeOut(out);
        out.writeInt(name.length());
        out.writeBytes(name);
    }

    public void readIn(DataInput in) throws IOException {
        super.readIn(in);
        int len = in.readInt();
        byte[] data = new byte[len];
        in.readFully(data);
        name = new String(data);
    }

    public int getSize() {
        return super.getSize() + 4 + name.length();
    }

    public short getCode() {
        return SAVEPOINT_LOG_CODE;
    }

    public String toString() {
        return "Set Savepoint '" + name + "'";
    }

    public String getName() {
        return name;
    }
}
