/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Dec 28, 2001
 * Time: 9:00:03 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.memorydb.index;

import freebase.util.SqlTypes;
import freebase.util.StringUtil;

/**
 * The same as a MultiValue, Holds the value of the columns if there are more than one for an index.  Otherwise just a lightweight
 * Comparable is used.  Bool is a legal Comparable Boolean value
 *
 * TODO:  handle nulls appropriately when they come
 *
 */
public class IndexKey implements Comparable {
    /**
     * key components
     */
    Comparable[] key;

    /**
     * any number is totally fine
     */
    int hashCode = 77;

    /**
     * Make an appropriate index key value placeholder for this object, either Comparable or Comparable[]
     * @param value
     * @return
     */
    public static Comparable makeKey(Object value) {
        /*   fine here, but maybe redundant
        if(value == null) {
            return null;
        }
        */

        if(value instanceof Comparable[]) {
            Comparable[] v = (Comparable[])value;
            /*if(v.length == 1) {  No longer valid due to need to have IndexKey object handle comparisons of different
                                 length values
                return v[0];
            }*/
            return new IndexKey((Comparable[])value);
        }

        if(value instanceof Comparable) {
            return (Comparable)value;
        }

        throw new RuntimeException("OH NO!  index key value not Comparable!");
    }


    /**
     *
     */
    public IndexKey(Comparable[] keyValue) {
        key = keyValue;

          //  TODO:  I'm too tired to come up with a better hashCode function ... and this is fast and probably fine
        for(int i = 0; i < key.length; i++) {
            int c;
            if(key[i] == null) {
                c = 19;  //  arbitrary
            } else {
                c = key[i].hashCode();
            }
            hashCode += (i + 1) * c;
        }

        //System.out.println("INDEX: found " + key[0]);
    }

    /**
     * Returns the whole value, generally for packing into log entries or whatever.  It's
     * nasty but works for now
     */
    public Object getValue() {
        if(key.length == 1)
            return key[0];
        else
            return key;
    }

    /**
     * Returns a portion of the value
     */
    public Comparable getValue(int pos) {
        return key[pos];
    }

    public boolean equals(Object o) {
        return compareTo(o) == 0;
    }

    public int hashCode() {
        return hashCode;
    }

    /**
     * Compare this index key with the one passed.  -1 mean this is less than o (correct ordering)
     */
    public int compareTo(Object o) {
        IndexKey other = (IndexKey)o;

        for(int i = 0; i < key.length; i++) {
            if(other.key.length == i) {
                  //  the other ran out of values, thus it must be before us
                return 1;
            }

              //  SqlTypes.compare is called because the BigDecimals can be compared with
              //  Integers and the like
            //System.out.println("COMPARING: " + key[i] + " and " + other.key[i]);
            int compare = SqlTypes.compareNullsEqual(key[i], other.key[i]);

            if(compare != 0)
                return compare;
        }

        if(other.key.length == key.length) {
            return 0;
        } else {
              //  if the other has a longer length, then it must come after
            return -1;
        }
    }

    public String toString() {
        return "IndexKey: " + StringUtil.dump(key);
    }
}
