package freebase.server;

import java.io.Serializable;


/**
 * Holds the result of an action to a database.
 */
public class ActionResult implements Serializable {
    /**
     *  for an update, this is the numbers.  otherwise don't know yet
     */
    long numRowsEffected;
    
    /**
     *  This code is to be used when it is suspected that a replica
     *  went down.  Pass this code into the backup node that takes over
     *  and it should be able to comply with the query -or- if it doesn't
     *  have enough data it will throw an irrecoverable exception forcing
     *  transaction to be rolled back.
     *
     *  Probably not meaningful to replay the last couple of operations
     *  because they might not play out the same way if re-done
     */
    long updateCode;


    /**
     *
     */
    public ActionResult(long numRowsEffected, long updateCode) {
        this.numRowsEffected = numRowsEffected;
        this.updateCode = updateCode;
    }

    public long getNumRowsEffected() {
        return numRowsEffected;
    }
}