/*
 * Copyright JJ Furman
 * User: user
 * Date: May 15, 2002
 * Time: 3:53:16 PM
 */
package freebase.server;

import freebase.api.TupleIterator;

import java.io.Serializable;

/**
 * The results of a batch of operations being done.
 */
public class BatchResult implements Serializable {
    int[] updateCounts;

    /**
     * Where there are nulls, the operation was not a query
     */
    TupleIterator[] queryResults;

    /**
     * Used to keep track of
     */
    transient int curPos = 0;

    public BatchResult(int expectedSize) {
        updateCounts = new int[expectedSize];
        queryResults = new TupleIterator[expectedSize];
    }

    public void addUpdateResult(int numUpdates) {
        updateCounts[curPos++] = numUpdates;
    }

    public void addQueryResult(TupleIterator ti) {
        queryResults[curPos++] = ti;
    }

    /**
     * TODO:  implement this correctly
     */
    public void setFinalLogPosition(long pos) {
    }


    public int[] getUpdateCounts() {
        return updateCounts;
    }
}
