/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 22, 2001
 * Time: 9:43:52 AM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.server;

import freebase.api.TupleIterator;

import java.rmi.RemoteException;
import java.sql.SQLException;

/**
 * Really should be called Tuple Streamer or something.  This class lives in the database server and
 * fetches row for the
 */
public class DataStreamerImpl implements DataStreamer {
    DBConnectionImpl sourceConnection;
    TupleIterator source;
    int numColumns;

    public DataStreamerImpl(DBConnectionImpl con, TupleIterator ti) throws SQLException {
        sourceConnection = con;
        source = ti;
        numColumns = source.getNumColumns();
    }

    /**
     * TODO:  eventually if end is near, rewrite the array and ship it
     *         do this possibly by multithreading it
     */
    public Comparable[][] getData(int numRows) throws SQLException {
        sourceConnection.enterActiveState();

        try{
        Comparable[][] returnSet = new Comparable[numRows][];

        for(int i = 0; i < returnSet.length; i++) {
            if(! source.next()) {
                returnSet[i] = null;
                return returnSet;
                //  TODO:  we are done, unexport ourselves
            }

            returnSet[i] = new Comparable[source.getNumColumns()];
            for(int j = 0; j < source.getNumColumns(); j++) {
                returnSet[i][j] = source.getValue(j);
            }
        }

        return returnSet;
        }catch(Throwable t) {
            t.printStackTrace();
            throw new SQLException("UNKNOWN ERROR: " + t.getMessage());
        }finally{
            sourceConnection.exitActiveState();
        }
    }

    /**
     * This is just a performance experiement, not serious code.  It is idiosyncratic to
     * say the least
     */
    public RowData[] getDataAsRows(int numRows) throws SQLException {
          //  assure that we are the only thread active on this connection
        sourceConnection.enterActiveState();

        try{
            RowData[] returnSet = new RowData[numRows];
            //System.out.println("SET IS: " + returnSet.length);
            for(int i = 0; i < returnSet.length; i++) {
                returnSet[i] = new RowData(source);
            }

        return returnSet;
        }catch(Throwable t) {
            t.printStackTrace();
            throw new SQLException("UNKNOWN ERROR: " + t.getMessage());
        }finally{
            sourceConnection.exitActiveState();
        }
    }

    /**
     * Closes the underlying cursor, as well as notifying the connection of one
     * less connection
     */
    public void close() throws SQLException, RemoteException {
        sourceConnection.removeActiveResult(source);
        source.close();
    }

    /**
     * Fetch the plan, man.  For now, do not add anything to the plan for the network hop.
     */
    public ExecutionPlan getExecutionPlan() throws SQLException, RemoteException {
        return source.getExecutionPlan();
    }
}


