/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 22, 2001
 * Time: 8:50:36 AM
 * To change template for new interface use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.server;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.sql.SQLException;

/**
 * LoginAgent is the exported frontend to the database.  It
 * requires a username and password to hand out a connection.
 *
 * TODO:  at least support challenge response!
 */
public interface LoginAgent extends Remote {
    DBConnection getConnection(String user, String password)
            throws RemoteException, SQLException;

    /*
    //optional:  enable salting of the keys
    byte[] getSalt();

    //  would return a (semi-)random byte[] challenge (C)
    byte[] getChallenge(String user);

    //  Assuming H is the hashing function, caller passes in H(challenge xor H(Password))
    //  This allows the server to not store the password in cleartext in the database.
    //  Due to the one way function H, H(password) cannot be computed because challenge xor H(password)
    //  cannot be computed.
    DBConnection getConnection(String user, byte[] challenge, byte[] response)
    */
}
