package freebase.server;

import freebase.log.LogEntryHeader;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 *  This is an object that represents the remote log
 *  this class helps keep the various logs in tight sync.
 *
 *  The implementation of this should not be published until the log
 *  object has been created.  This is designed to be high level, not fast.
 *  If you want fast, get a ferrari
 * @deprecated
 */
public interface RemoteLogInterface extends Remote {
    /**
     *  used on startup to determine who is the one with the most information
     */
    long getMaxLSN() throws RemoteException;
    
    /**
     *  the caller sends an entry to the remote server, either upon startup
     *  or during live broadcast.  It should be obvious from the type of
     *  entry whether flushing is required or not.
     */
    void receiveEntry(LogEntryHeader header, byte[] data) throws RemoteException;
    
    void receiveEntries(LogEntryHeader[] headers, byte[][] datas) throws RemoteException;
}
