/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Dec 27, 2001
 * Time: 9:45:22 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.sql;

import java.util.ArrayList;

public class CreateIndexStatement extends DDLStatement {
    String indexName;
    TableRef table;
    ArrayList columnList = new ArrayList();
    boolean unique = false;


    /**
     * Construct an empty create table statement.  Used in the sql parser.
     */
    public CreateIndexStatement() {}

    /**
     * Construct a create table statement with one column.  Mostly used for internal testing, thus
     * reproduce the uppercase of the tableref code
     */
    public CreateIndexStatement(String indexName, String schema, String table, String column, boolean unique) {
        this.indexName = indexName.toUpperCase();
        setTable(new TableRef(schema.toUpperCase(), table.toUpperCase()));
        addColumn(column);
        this.unique = unique;
    }

    /**
     * TODO:  this might not be right, haven't tested creating indexes in other schema's
     * @param indexName
     */
    public void setIndexName(String indexName) {
        this.indexName = indexName;
    }

    public void setUnique(boolean u) {
        unique = u;
    }

    public boolean isUnique() {
        return unique;
    }

    public void setTable(TableRef table) {
        this.table = table;
    }

    public String getIndexName() {
        return indexName;
    }

    public TableRef getTable() {
        return table;
    }

    public void addColumn(String column) {
        columnList.add(column);
    }

    public ArrayList getColumns() {
        return columnList;
    }

    public String[] getColumnsArray() {
        String[] fields = new String[getColumns().size()];
        getColumns().toArray(fields);
        return fields;
    }
}
