/*
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: Sep 18, 2001
 * Time: 8:45:36 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.sql;

import java.util.ArrayList;

/**
 * All the information from a create table statement.
 */
public class CreateTableStatement extends DDLStatement {
    TableRef table;

    ArrayList columnDefs = new ArrayList();

    /**  TODO:  add the pk info to the actual table
     *  primary key info
     */
    String pkField;
    String pkConstraintName;

    ArrayList uniqueConstraints = new ArrayList();

    public CreateTableStatement() { }

    public String getTableName() {
        return table.getTable();
    }

    public void setTableName(TableRef ref) {
        this.table = ref;
    }

    public TableRef getTable() {
        return table;
    }

    public String getSchema() {
        return table.getSchema();
    }

    public void setSchema(String schema) {
        this.table.setSchema(schema);
    }

    /**
     * TODO:  determine if it is ok if this gets called twice (assume no)
     */
    public void setPrimaryKey(String fieldName, String constraintName) {
        this.pkField = fieldName;
        this.pkConstraintName = constraintName;
    }

    public void addUniqueConstraint(UniqueConstraint unik) {
        uniqueConstraints.add(unik);
    }

    public void addColumn(ColumnDefinition colDef) {
        columnDefs.add(colDef);
    }

    public int getNumColumns() {
        return columnDefs.size();
    }

    public ColumnDefinition getColumn(int i) {
        return (ColumnDefinition)columnDefs.get(i);
    }

    /**
     * Print out this statement
     */
    public String toString() {
        StringBuffer sb = new StringBuffer("Statement: create table " + getTableName());
        return sb.toString();
    }
}
