/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 19, 2001
 * Time: 8:17:54 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.sql;

import java.io.Serializable;

/**
 * Names are pre-converted to SQL in the parser -> UPPER unless "Quoted"
 */
public class TableRef implements Serializable {
    String schema;
    String table;

    public TableRef(String schema, String table) {
        this.schema = schema;
        this.table = table;
    }

    public TableRef(String table) {
        this(null, table);
    }

    public String getSchema() {
        return schema;
    }

    /**
     * Returns the local schema unless it is null, then it returns the default schema
     */
    public String getSchema(String defaultSchema) {
        if(schema == null)
            return defaultSchema;

        return schema;
    }

    public String getTable() {
        return table;
    }

    public void setSchema(String schema) {
        this.schema = schema;
    }

    public void setTable(String table) {
        this.table = table;
    }

    public void applyDefaultSchema(String user) {
        if(getSchema() == null)
            schema = user;
    }

    public void writeToBuffer(StringBuffer sb) {
        if(schema != null) {
            sb.append(schema);
            sb.append('.');
        }

        sb.append(table);
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        writeToBuffer(sb);
        return sb.toString();
    }
}
