/*
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: Sep 10, 2001
 * Time: 10:15:40 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.sql;

import freebase.sql.expression.ExpressionVisitor;

import java.sql.SQLException;
import java.util.ArrayList;

public class UpdateStatement extends DMLStatement {
    TableRef table;
    ArrayList setColumns = new ArrayList();
    ArrayList setValues = new ArrayList();

    SqlCondition condition;

    /**
     * Bind the literals in order
     */
    public int bindLiterals(Comparable[] values, int curPos) throws SQLException {
          //  bind column expressions
        for(int i = 0; i < getNumSets(); i++) {
            curPos = getSetExpr(i).bindLiterals(values, curPos);
        }

          //  bind condition
        if(getCondition() != null) {
            curPos = getCondition().bindLiterals(values, curPos);
        }

        return curPos;
    }

    /**
     * bind sequences for all column sets!!
     * @throws SQLException
     */
    public void bindSequences(ExpressionVisitor seqBinder) throws SQLException {
          //  bind column expressions only
        for(int i = 0; i < getNumSets(); i++) {
            getSetExpr(i).accept(seqBinder);
        }
    }

    public SqlCondition getCondition() {
        return condition;
    }

    public void addSetColumn(ColumnRef col) {
        setColumns.add(col);
    }

    public void addSetValue(SqlExpression val) {
        setValues.add(val);
    }

    public String getSchema() {
        return table.getSchema();
    }

    public String getTableName() {
        return table.getTable();
    }

    public void setTable(TableRef tableRef) {
        this.table = tableRef;
    }

    public void setCondition(SqlCondition cond) {
        condition = cond;
    }

    public int getNumSets() {
        return setColumns.size();
    }

    public ColumnRef getSetColumn(int i) {
        return (ColumnRef)setColumns.get(i);
    }

    public SqlExpression getSetExpr(int i) {
        return (SqlExpression)setValues.get(i);
    }
}
