/*
 * Copyright JJ Furman
 * User: user
 * Date: Apr 17, 2002
 * Time: 2:57:21 PM
 */
package freebase.sql.function;

import freebase.sql.function.aggregation.*;
import freebase.sql.function.standard.*;

import java.sql.SQLException;
import java.util.HashMap;

/**
 * The central.  TODO:  make this a visitor?
 */
public class FunctionManager {
    HashMap functions = new HashMap();

    /**
     * TODO:  add methods for adding functions.  For now just use a nasty
     */

    public FunctionManager() {
          //  standard functions
        functions.put("ABS", new AbsFunction());
        functions.put("LOWER", new LowerFunction());
        functions.put("UPPER", new UpperFunction());
        functions.put("RANDOM_DOUBLE", new RandomDouble());  //  TODO:  make it end in "Function"?
        functions.put("SYSDATE", new CurrentTime());

          //  aggregation functions
        functions.put("AVG", new AvgFunctionFactory());
        functions.put("COUNT", new CountFunctionFactory());
        functions.put("MAX", new MaxFunctionFactory());
        functions.put("MIN", new MinFunctionFactory());
        functions.put("SUM", new SumFunctionFactory());
        functions.put("GROUP_CONCAT", new GroupConcatFunctionFactory());
        functions.put("CHOOSE_MAX", new ChooseMaxFunctionFactory());
    }

    public Function getFunction(String name) throws SQLException {
        FunctionFactory factory = (FunctionFactory)functions.get(name);

        if(factory == null) {
            throw new SQLException("Invalid function name '" + name + "'");
        }

        return factory.getFunction();
    }
}
