/*
 * Copyright JJ Furman
 * User: user
 * Date: May 10, 2002
 * Time: 11:16:01 AM
 */
package freebase.sql.function.aggregation;

import freebase.sql.function.AggregationFunction;
import freebase.sql.function.Function;
import freebase.sql.function.FunctionFactory;

import java.sql.SQLException;

public class MaxFunctionFactory implements FunctionFactory {
    public Function getFunction() {
        return new MaxFunction();
    }
}


class MaxFunction extends AggregationFunction {
    Comparable max = null;

    /**
     * Note sure if f(null) is always null, but for now
     * I assume not!
     */
    public void addValue(Comparable val) throws SQLException {
        if(val == null) {
            return;
        }

        if(max == null) {
            max = val;
        } else {
            if(max.compareTo(val) < 0) {
                max = val;
            }
        }
    }

    public Comparable getResult() throws SQLException {
        return max;
    }

    public void reset() throws SQLException {
        max = null;
    }

    /**
     * Only count accepts full tuples for now.
     */
    public boolean acceptsFullTuples() throws SQLException {
        return false;
    }
}

