/*
 * Copyright JJ Furman
 * User: user
 * Date: May 10, 2002
 * Time: 11:05:05 AM
 */
package freebase.sql.function.aggregation;

import freebase.sql.function.AggregationFunction;
import freebase.sql.function.Function;
import freebase.sql.function.FunctionFactory;

import java.sql.SQLException;

public class MinFunctionFactory implements FunctionFactory {
    public Function getFunction() {
        return new MinFunction();
    }
}


class MinFunction extends AggregationFunction {
    Comparable min = null;

    /**
     * Note sure if f(null) is always null, but for now
     * I assume not!
     */
    public void addValue(Comparable val) throws SQLException {
        if(val == null) {
            return;
        }

        if(min == null) {
            min = val;
        } else {
            if(min.compareTo(val) > 0) {
                min = val;
            }
        }
    }

    public Comparable getResult() throws SQLException {
        return min;
    }

    public void reset() throws SQLException {
        min = null;
    }

    /**
     * Only count accepts full tuples for now.
     */
    public boolean acceptsFullTuples() throws SQLException {
        return false;
    }
}
