/*
 * Copyright JJ Furman
 * User: user
 * Date: May 10, 2002
 * Time: 12:15:05 PM
 */
package freebase.sql.function.aggregation;

import freebase.sql.function.AggregationFunction;
import freebase.util.NumberUtil;

import java.math.BigDecimal;
import java.sql.SQLException;


/**
 * TODO:  the implementation of this is pretty slow.  It always creates lots of new
 * BigDecimals!!!  change it sometime
 */
public class SumFunction extends AggregationFunction {
    BigDecimal sum = null;

    /**
     * Note sure if f(null) is always null, but for now
     * I assume not!
     */
    public void addValue(Comparable val) throws SQLException {
        if(val == null) {
            return;
        }

          //  TODO:  could move this to the validation phase
        if(! (val instanceof Number)) {
            throw new SQLException("SUM expression not a number");
        }

          //  ouch!
        BigDecimal num = NumberUtil.convertToBigDecimal((Number)val);

        if(sum == null) {
            sum = num;
        } else {
            sum = sum.add(num);
        }
    }

    public Comparable getResult() throws SQLException {

        return sum;
    }

    public void reset() throws SQLException {
        sum = null;
    }

    /**
     * Only count accepts full tuples for now.
     */
    public boolean acceptsFullTuples() throws SQLException {
        return false;
    }
}
