package freebase.sql.function.standard;

import freebase.api.ColumnInfo;
import freebase.sql.function.StandardFunction;

import java.math.BigDecimal;
import java.sql.SQLException;
import java.sql.Types;

/**
 * Copyright Mar 14, 2004 JJ Furman
 * Time: 10:30:53 PM
 */
public class RandomDouble extends StandardFunction {
    final static ColumnInfo outputCol = new ColumnInfo("RANDOM_DOUBLE", Types.DOUBLE);

    public ColumnInfo getColumnInfo(ColumnInfo[] inputs) throws SQLException {
        if(inputs.length != 0) {
            throw new SQLException("RANDOM_DOUBLE() function only takes no arguments");
        }

        return outputCol;
    }

    public Comparable evaluate(Comparable[] input) throws SQLException {
        return new BigDecimal(Math.random());
    }
}
