/*
 * Copyright JJ Furman
 * User: user
 * Date: May 15, 2002
 * Time: 12:45:15 PM
 */
package freebase.sql.function.standard;

import freebase.api.ColumnInfo;
import freebase.sql.function.StandardFunction;

import java.sql.SQLException;

/**
 * Upper cases the data...
 */
public class UpperFunction extends StandardFunction {
    public ColumnInfo getColumnInfo(ColumnInfo[] inputs) throws SQLException {
        if(inputs.length != 1) {
            throw new SQLException("UPPER function only takes one argument");
        }

        return inputs[0];
    }

    public Comparable evaluate(Comparable[] input) throws SQLException {
          //  validate inputs
        if(input.length != 1) {
            throw new SQLException("UPPER function only takes one argument");
        }

        if(input[0] == null) {
            return null;
        }

        if(! (input[0] instanceof String)) {
            throw new SQLException("UPPER function only takes a string argument");
        }

        return ((String)input[0]).toUpperCase();
    }
}
