package freebase.sql.plan.prepared;

import java.util.ArrayList;

/**
 * Related to the java.sql.PreparedStatement in that this is the internal database
 * implementation of a pre-planned statement
 * TODO:  perhaps rename this CachedStatement or something less confusing
 * TODO:  implement invalidate method
 *
 */
public class PreparedStatement {
    /**
     * list of use locks that must be obtained before this statement
     * is instantiated into an executatble statement
     */
    ArrayList useLocks = new ArrayList();

    /**
     * is currently volatile because this will be checked by
     * a cleanup thread periodically in the statement cache.  Technically
     * this should not be necessary since in all cases the settting of this
     * will coincide (soon enough) with a memory barrier
     */
    volatile boolean isValid = true;

    ExecutableStatement prototype;

    public ExecutableStatement getExecutableStatement() {
        //  grab all use locks
        //  check is valid
        //  if yes, instantiate executable statement
        //  unlock use locks
        //  return instantiation/clone
        return null;
    }
}
