package freebase.store;


/**
 *  The table page has the format:
 *  Header:
 *
 *  row data:
 *
 *  freespace if any:
 *
 *  offsets to rows:  n x (status as byte, posOfNext as short)
 *  number of rows:  n as byte
 */
public class TablePageInterface extends ContentPageInterface {
    byte scaleFactor = 1;
    
    int numRowsPos;
    
    public TablePageInterface(int blockSize) {
        super(blockSize);
        
        numRowsPos = blockSize - Block.FOOTER_SIZE - 1;
    }
    
    /**
     *  the actual value is between 0 and 254 so short will do
     */
    public short getNumRows(Block b) {
        short rows = b.data[numRowsPos];
        return (short) (rows & 0x00ff);
    }
    
    
    /**
     *  returns the usable freespace of actual data that could fit in a new
     *  new row.  about 3 less than how much an existing row could be extended
     */
    public int getFreespace(Block b) {
        return -1;
    }
}