/*
 * Copyright JJ Furman
 * User: user
 * Date: Mar 14, 2002
 * Time: 9:00:07 AM
 */
package freebase.test;

import freebase.server.DBConnection;
import freebase.server.DatabaseNode;
import freebase.sql.*;

import java.rmi.RemoteException;
import java.sql.SQLException;
import java.sql.Types;

/**
 * If an argument "runscript" is passed in, then this gets called.  It is for doing programmatic tests
 */
public class BootScript {
    /**
     * script entry point
     */
    public static void runScript(DatabaseNode dbNode) throws SQLException, RemoteException {
        long startTime = System.currentTimeMillis();

        DBConnection con = DatabaseNode.getLocalDBConnection("JJ", "nothing");
        //DBConnection con = DatabaseNode.getRemoteDBConnection("localhost", 0, "TEST", "JJ", "PASSWORD");

        CreateTableStatement createTable = new CreateTableStatement();
        createTable.setTableName(new TableRef("TEST1"));
        createTable.addColumn(new ColumnDefinition("ID", Types.INTEGER, 11, 0, true));
        createTable.addColumn(new ColumnDefinition("NAME", Types.VARCHAR, 255, 0, true));
        createTable.addColumn(new ColumnDefinition("DATA", Types.VARCHAR, 255, 0, true));
        createTable.addColumn(new ColumnDefinition("NUMBER", Types.INTEGER, 11, 0, true));

        con.executeAction(createTable);

          //  TODO:  consider the prepared statement version of this bad boy, it will be faster
        InsertStatement ins;
        for(int i = 0; i < 100000; i++) {
            ins = new InsertStatement("TEST1", new String[] {"" + i, "'Something for sure'", "'Another little something" + i + "'", "" + 5});
            con.executeAction(ins);

            //if(i % 1000 == 0)
            //    System.out.println("@ " + i + "  mem:" + Runtime.getRuntime().freeMemory());
        }

        con.executeAction(new CommitStatement());

        double time = System.currentTimeMillis() - startTime;
        time = time / 1000;
        System.out.println("TOOK: " + time);
    }
}
