/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 20, 2001
 * Time: 8:41:10 AM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.test;

import java.sql.*;


public class OracleTest {
    static Connection con;

    public static void main(String[] args) throws Throwable {
        Class.forName("oracle.jdbc.OracleDriver");

          //  local test, to remove
        //StartDaemon.startDatabaseServer().createTestSchema();
        //con = JDBCTest.getF3Connection();

        con = DriverManager.getConnection("jdbc:oracle:thin:jj/password@192.168.123.123:1521:TEST");
        con.setAutoCommit(false);

          //  put oracle test line here
        testBasicPreparedStatement();

        con.close();
    }

    public static void testBasicPreparedStatement() throws SQLException {
        PreparedStatement ps = con.prepareStatement("select ? from nums");
        ps.setBoolean(1, true);
        ResultSet rs = ps.executeQuery();

        ResultSetMetaData meta = rs.getMetaData();
        for(int i = 0; i < meta.getColumnCount(); i++) {
            System.out.println("TYPE @" + i + ":  " + meta.getColumnType(i+1) + " prec: "+ meta.getPrecision(i+1) +  " scale : " + meta.getScale(i+1));
            System.out.println("    CAT:'" +  meta.isNullable(i+1) + "'  '" + meta.getColumnLabel(i+1) + "' '" + meta.getTableName(i+1) + "' '" +meta.isSearchable(i+1) + "'");
        }

        ps.close();
        rs.close();
    }

    /***************************************************************
     * specific tests
     */

    public static void getTypesAndSizes() throws SQLException {
        Statement st = con.createStatement();

        ResultSet rs = st.executeQuery("select null, id, id+id, id/3, name||name||name || 'f' from names where id < 2");
        //ResultSet rs = st.executeQuery("select to_char(5) from new");

        ResultSetMetaData meta = rs.getMetaData();
        for(int i = 0; i < meta.getColumnCount(); i++) {
            System.out.println("TYPE @" + i + ":  " + meta.getColumnType(i+1) + " prec: "+ meta.getPrecision(i+1) +  " scale : " + meta.getScale(i+1));
            System.out.println("    CAT:'" +  meta.isNullable(i+1) + "'  '" + meta.getColumnLabel(i+1) + "' '" + meta.getTableName(i+1) + "' '" +meta.isSearchable(i+1) + "'");
        }

        st.close();
        rs.close();
    }


    public static void multiThreadJDBCTest() throws SQLException, InterruptedException {
        new Thread() {
            public void run() {
                try{
                    Thread.sleep(500);

                    Statement st = con.createStatement();
                    st.execute("lock table test2 in exclusive mode");
                    System.out.println("GOT HERE");

                }catch(Throwable t) {
                    t.printStackTrace();
                }
            }
        }.start();

        Statement st = con.createStatement();
        System.out.println("about to query...");
        ResultSet rs = st.executeQuery("select * from test2 a");
        System.out.println("got results");
        Thread.sleep(1000);
        System.out.println("fetching them...");
        int count = 0;
        while(rs.next()) {
            count++;
        }
        System.out.println("got all");

        System.out.println("count was " + count);
        rs.close();
        st.close();
    }


    public static void doNumberTest() throws SQLException {
        //  0.333 333 333  333 333 333  333 333 333  333 333 333  333 3



        Statement st = con.createStatement();
        ResultSet rs = st.executeQuery("select 1/3, 1/3 + 1/3 + 1/3 from test3");
        while(rs.next()) {
            System.out.println(rs.getObject(1) + " , " + rs.getObject(2));
        }
    }


    public static void lotsOfInserts(Connection con) throws Throwable {
        long time = System.currentTimeMillis();
        PreparedStatement ps = con.prepareStatement("insert into test values (?,?)");
        for(int i = 0; i < 100000; i++) {
            ps.setInt(1, i);
            ps.setString(2, "BOB" + i);
            ps.execute();
        }

        con.commit();

        System.out.println((System.currentTimeMillis() - time));
        ps.close();
    }


    //public static void
}
