/*
 * Copyright JJ Furman
 * User: user
 * Date: May 7, 2002
 * Time: 10:40:05 AM
 */
package freebase.test;

import java.io.PrintStream;
import java.io.PrintWriter;

/**
 * Throws when a test fails.
 */
public class TestFailedException extends RuntimeException {
    Throwable sub;

    public TestFailedException(String message) {
        super(message);
    }

    /**
     * one with a nested exception
     */
    public TestFailedException(String message, Throwable t) {
        super(message);
        sub = t;
    }

    /****************
     * methods for printing sub exceptions
     */

    public void printStackTrace(PrintStream ps) {
        PrintWriter pw = new PrintWriter(ps);
        printStackTrace(pw);
        pw.flush();
    }

    public void printStackTrace() {
        printStackTrace(System.err);
    }


    public void printStackTrace(PrintWriter pw) {
        synchronized(pw) {
            if(sub != null)
                pw.println(this + ": ");


            if(sub == null) {
                super.printStackTrace(pw);
            } else {
                pw.print("Sub exception is: ");
                sub.printStackTrace(pw);
            }
        }
    }
}
