/*
 * Copyright JJ Furman
 * User: user
 * Date: Mar 19, 2002
 * Time: 7:02:57 AM
 */
package freebase.tools;

import freebase.StartDaemon;
import freebase.api.LogManager;
import freebase.log.LogEntryHeader;
import freebase.log.LogEntryManager;
import freebase.server.DatabaseNode;
import freebase.util.Props;

/**
 * Execute this to dump the contents of the log out to the terminal.  Default behavior should be
 * to dump from the current anchor point only
 */
public class DumpLog {

    public static void main(String[] args) throws Throwable {
        StartDaemon.initProperties(args);

        LogManager log = (LogManager)Props.getClass(DatabaseNode.LOG_CLASS_PROPERTY).newInstance();

        //SimpleFile log = new SimpleFileLogManager("logfile.hex");
        log.setLogEntryManager(new LogEntryManager());

        LogEntryHeader header = log.getLogEntry(0);
        while(header != null) {
            System.out.println(header);

            header = log.getLogEntry(header.getNextLSN());
        }
    }
}
