package freebase.util;

import java.math.BigDecimal;
import java.util.Date;

/**
 * TODO:  this is redundant with SqlTypes!  Figure out the best one and be done!
 * Copyright 2004 JJ Furman
 * Time: 6:44:35 PM
 */
public class CompareUtil {
    public static boolean isEqual(Object a, Object b) {
          //  null != anything, even null
        if(a == null || b == null) {
            return false;
        }

          //  a is not null
        if(b == null) {
            return false;
        }

          //  handle strings
        if(GlobalProps.isStringsCaseInsensitive()) {
            if(a instanceof String) {
                if(! (b instanceof String)) {
                    return false;
                }

                String aString = (String)a;
                String bString = (String)b;
                return aString.equalsIgnoreCase(bString);
            }
        }

          //  even different kinds (like Timestamp and java.sql.Date)
        if(a instanceof Date) {
            if(! (b instanceof Date)) {
                return false;
            }

            long aTime = ((Date)a).getTime();
            long bTime = ((Date)b).getTime();

            return aTime == bTime;
        }

        if(a instanceof Number) {
            return compareNumbers((Number)a, (Number)b) == 0;
        }

        return a.equals(b);
    }

    /**
     * Compensates for Java's inability to compare numbers correctly, duh.<BR>
     * Java really dropped the ball on this one.  Integer.compare(BigDecimal) <BR>
     * should work!
     */
    public static int compareNumbers(Number a, Number b) {
        BigDecimal bigA = convertToBigDecimal(a);
        BigDecimal bigB = convertToBigDecimal(b);

        return bigA.compareTo(bigB);
    }

    /**
     * The number passed in is converted to BigDecimal if it isn't already
     */
    public static BigDecimal convertToBigDecimal(Number number) {
        if(number instanceof BigDecimal)
            return (BigDecimal)number;
        else if(number instanceof Double || number instanceof Float)
            return new BigDecimal(number.doubleValue());
        else
            return BigDecimal.valueOf(number.longValue());
    }
}
