/**
 * Copyright 2004 JJ Furman
 * Time: 5:13:47 PM
 */
package freebase.util;

import java.util.ArrayList;
import java.util.WeakHashMap;

/**
 * An associative log.  Journal things associated with an object and not require changing the object itself.
 * In a way I could have used log4j or something but they get ugly and confusing.
 */
public class DebugLog {
    static WeakHashMap log = new WeakHashMap();


    public synchronized static void log(Object source, Object data) {
        ArrayList list = (ArrayList)log.get(source);
        if(list == null) {
            list = new ArrayList();
            log.put(source, list);
        }
        list.add(data);
    }

    public synchronized static void clear(Object source) {
        log.remove(source);
    }

    public synchronized static void clearAll() {
        log.clear();
    }

    public synchronized static void printLog(Object source) {
        ArrayList list = (ArrayList)log.get(source);
        System.out.print("log for object " + source + ": ");
        if(list == null) {
            System.out.println("null");
        } else {
            System.out.println();
            for(int i = 0; i < list.size(); i++) {
                System.out.println(list.get(i));
            }
        }
    }
}

