/*
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: Sep 18, 2001
 * Time: 8:42:29 PM
 * To change template for new interface use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.util;

import java.sql.SQLException;

/**
 * NO, I don't want to hear about the constants anti-pattern.
 * TODO:  rework this to use a LongHashMap and have loose codes, not sequential
 * TODO:  make a nice automated report for this one
 * TODO:  all errors can be a V$TABLE
 */
public class ErrorCode {
    final public static int SCHEMA_DOES_NOT_EXIST = 0;
    final public static int SCHEMA_ALREADY_EXISTS = 1;

    final public static int TABLE_DOES_NOT_EXIST = 2;
    final public static int TABLE_ALREADY_EXISTS = 3;

    final public static int INDEX_DOES_NOT_EXIST = 4;
    final public static int INDEX_ALREADY_EXISTS = 5;

    final public static int SAVEPOINT_NEVER_DEFINED = 6;

    final public static int UNIQUE_KEY_VIOLATION = 7;

    final public static int DEBUG_EXCEPTION = 8;

    final public static int SEQUENCE_DROPPED = 9;
    final public static int FUNCTION_NOT_COMPLETED = 10;
    final public static int SEQUENCE_DOES_NOT_EXIST = 11;
    final public static int SEQUENCE_ALREADY_EXISTS = 12;
    final public static int TOO_MANY_CURSORS = 13;
    final public static int STRING_TOO_LONG = 14;
    final public static int CANT_SERIALIZE = 15;
    final public static int INTERNAL_ERROR = 16;
    final public static int COLUMN_NOT_NULLABLE = 17;

    final public static int EXPRESSION_NOT_NUMBER = 18;
    final public static int EXPRESSION_NOT_DATE = 19;
    final public static int EXPRESSION_NOT_TIMESTAMP = 19;


    final static String[] text = {
        "Schema does not exist",
        "Schema already exists",
        "Table does not exist",
        "Table already exists",
        "Index does not exist",
        "Index already exists",
        "Savepoint never defined",
        "Unique Key Violation",
        "Debug Exception - Should never get in production",
        "Sequence in use has been dropped by another process!",
        "The function you requested is not completed",
        "Sequence does not exist",
        "Sequence already exists by that name",
        "Too many outstanding cursors for object",
        "Failed to put string into column, too big",
        "Can't Serialize operations",
        "Internal Error",
        "Column is not nullable",
        "Expression is not a number",
        "Expression is not a time value",
    };

    //final public static int OPERA

    public static void throwException(int code) throws SQLException {
        throw new SQLException(text[code], "not sure yet", code);
    }

    public static void throwException(int code, String additionalInfo) throws SQLException {
        throw new SQLException(text[code] + ": " + additionalInfo, "not sure yet", code);
    }

    public static String getStandardMessage(int code) {
        return text[code];
    }
}
