package freebase.util;


/**
 *  a faux share... really only allows one to hold this at a time.
 * TODO:  use the concurrent package
 */
public class FauxShareSemaphore extends ShareLock {
    boolean beingHeld = false;
    
    public boolean getLockShared(int timeout) {
        return getLockExclusive(timeout);
    }

    /**
     * Caller needs to catch InterruptedException and throw up SQL or whatever is appropriate
     */
    public synchronized boolean getLockExclusive(int timeout) {
        while(beingHeld) {
            try{
                wait(timeout);
            }catch(InterruptedException ie) {
                ie.printStackTrace();
            }
            
            if(timeout != 0 && beingHeld)
                return false;
        }
        
        beingHeld = true;
        return true;
    }
    
    public void releaseLockShared() {
        releaseLockExclusive();
    }
    
    public synchronized void releaseLockExclusive() {
        beingHeld = false;
        notify();
    }
}