/*
 * Copyright JJ Furman
 * User: user
 * Date: Feb 24, 2003
 * Time: 6:25:38 PM
 */
package freebase.util;

import java.io.*;

public class FileHelper {
    public static void ensureParentDirExists(File anything) {
        ensureDirExists(anything.getParentFile());
    }

    public static void ensureDirExists(File dir) {
        if(dir == null) {
            return;
        }
        if(! dir.exists()) {
            ensureDirExists(dir.getParentFile());
            dir.mkdir();
        }
    }

    /**
     *  Copies the file from src to dest
     */
    public static void copyFile(File src, File dest) throws IOException {
        InputStream in = null;
        OutputStream out = null;
        try{
            FileHelper.ensureParentDirExists(dest);

            in = new FileInputStream(src);
            out = new FileOutputStream(dest);

            byte[] buf = new byte[64000];

            int red;
            while((red = in.read(buf)) != -1) {
                out.write(buf, 0, red);
            }

            in.close();
            out.close();
        }catch(IOException i) {
            try{
                if(in != null)
                    in.close();
            }catch(Exception ii) {

            }

            try{
                if(out != null)
                    out.close();
            }catch(Exception ii) {

            }

            throw i;
        }
    }
}
