/*
 * Copyright JJ Furman
 * User: user
 * Date: Apr 26, 2002
 * Time: 10:01:28 AM
 */
package freebase.util;

import java.io.PrintStream;

/**
 * This is a debug tool for finding spurious System.out's.  It will print a stack tract when it sees
 * the search string.  If you can't find a print because someone has put in System.out.println(var) or something
 * this can help when you see a specific value.
 */
public class PrintTracer extends PrintStream {
    String searchString;
    PrintStream out;

    public PrintTracer(PrintStream out, String searchString) {
        super(out);

        this.out = out;
        this.searchString = searchString;
    }

    public void println(String x) {
        if(x.equals(searchString)) {
            new Exception("TRACER:  Found search string").printStackTrace(out);
        }

        super.println(x);
    }

    public void print(String s) {
        if(s.equals(searchString)) {
            new Exception("TRACER:  Found search string").printStackTrace(out);
        }

        super.print(s);
    }


    public static void replaceSystemOutWithTracer(String search) {
        System.setOut(new PrintTracer(System.out, search));
    }
}
