package freebase.util;


/**
 *  represents the interface for a shared semaphore.
 *
 * TODO:  add in correct behavior for when interrupt signal is sent.  Probably throw an SQLException.
 *     Implement this to call Doug Leags (ie, this can now be a concrete implementation)
 *
 * The only time it isn't required that the interrupt signal be processed is when:
 * 1.  it is guarenteed that the thread will eventually get the lo
 */
public abstract class ShareLock {
    public void getLockShared() {
        getLockShared(0);
    }
    
    public void getLockExclusive() {
        getLockExclusive(0);
    }
    
    public abstract boolean getLockShared(int timeout);
    public abstract boolean getLockExclusive(int timeout);
    
    public abstract void releaseLockShared();
    public abstract void releaseLockExclusive();
}
