/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Jan 6, 2002
 * Time: 8:06:34 PM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.util;

import freebase.parser.ParseException;
import freebase.parser.SqlParser;
import freebase.sql.SqlStatement;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Handles opening an sql file and parsing the input as statements
 */
public class SqlFileHandler {
    File sqlFile;

    /**
     * Contains statements and errors...
     */
    ArrayList sqlStatements = new ArrayList();

    public SqlFileHandler(String file) throws IOException {
        sqlFile = new File(file);

          //  parse the file into sql statements
        BufferedInputStream in = new BufferedInputStream(new FileInputStream(sqlFile));
        SqlParser parser = new SqlParser(in);

        boolean done = false;
        while(! done) {
            try{
                SqlStatement s = parser.TerminatedStatement();

                if(s == null) {
                    done = true;
                } else {
                    sqlStatements.add(s);
                    System.out.println(s);
                }
            }catch(ParseException pe) {
                sqlStatements.add(pe);
                System.out.println(pe);
            }
        }

        in.close();
    }

    public int getNumStatements() {
        return sqlStatements.size();
    }

    public boolean isError(int pos) {
        return sqlStatements.get(pos) instanceof Throwable;
    }

    public Throwable getError(int pos) {
        return (Throwable)sqlStatements.get(pos);
    }

    public SqlStatement getStatement(int pos) {
        return (SqlStatement)sqlStatements.get(pos);
    }

    /**
     * Test entry point
     */
    public static void main(String[] args) throws IOException {
        SqlFileHandler s = new SqlFileHandler("catalog/create_system.sql");

    }
}
