/*
 * Copyright JJ Furman
 * User: user
 * Date: Apr 17, 2002
 * Time: 11:53:10 AM
 */
package freebase.util;

import java.io.IOException;
import java.io.InputStream;



/**
 * Reads the data from a string buffer.  This may not end up being fast enough.
 */
public class StringBufferInputStream extends InputStream {
    StringBuffer sb;

    int pos = 0;

    public StringBufferInputStream(StringBuffer sb) {
        this.sb = sb;
    }

    public int read() throws IOException {
        if(pos >= sb.length())
            return -1;
        int val = sb.charAt(pos++);
        val &= 0x000000ff;
        return val;
    }
}
