/*
 * Copyright JJ Furman
 * User: user
 * Date: Apr 25, 2002
 * Time: 3:11:34 PM
 */
package freebase.util;

import java.io.IOException;
import java.io.InputStream;

/**
 *  Outputs string data in byte per character format to the caller.
 */
public class StringInputStream extends InputStream {
    String source;
    int curPos = 0;

    /**
     * Later
     */
    public StringInputStream(String source) {
        this.source = source;
    }

    /**
     * reads the data from a string one character at a time
     */
    public int read() throws IOException {
        if(curPos >= source.length())
            return -1;

        return (int)source.charAt(curPos++);
    }
}
