/*
 * Created by IntelliJ IDEA.
 * User: administrator
 * Date: Nov 17, 2001
 * Time: 11:14:53 AM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package freebase.util;

import freebase.parser.ParseException;

public class StringUtil {
    /**
     * Basically converts name from lower to upper case, but will
     * leave them if the name is quoted.
     */
    public static String convertSqlName(String name) throws ParseException {
        if(name == null)
            return null;
        if(name.charAt(0) == '"') {
            //System.out.println("WARNING: not implemented found a \"'ed name " + name + " but did not convert it correctly");
            if(name.charAt(name.length() - 1) != '"') {
                throw new ParseException("Quoted string [" + name + "] must end in a quote");
            }

            return name.substring(1, name.length() - 1);
        }

        return name.toUpperCase();
    }


    public static String dump(Object[] set) {
        StringBuffer sb = new StringBuffer();
        writeToBuffer(sb, set);
        return sb.toString();
    }

    public static void writeToBuffer(StringBuffer sb, Object[] data) {
        if(data == null) {
            sb.append("null");
            return;
        }

        sb.append('(');
        for(int i = 0; i < data.length; i++) {
            if(i != 0)
                sb.append(',');
            sb.append(data[i]);
        }
        sb.append(')');
    }

    public static String dump(int[] set) {
        StringBuffer sb = new StringBuffer();
        writeToBuffer(sb, set);
        return sb.toString();
    }

    public static void writeToBuffer(StringBuffer sb, int[] data) {
        if(data == null) {
            sb.append("null");
            return;
        }

        sb.append('(');
        for(int i = 0; i < data.length; i++) {
            if(i != 0)
                sb.append(',');
            sb.append(data[i]);
        }
        sb.append(')');
    }

    /**
     *  method used in GenerateApis
     *  converts database names to java names like
     *  card_users -> CardUsers
     */
    public static String makeNice(String name) {
        name = name.toLowerCase();
        StringBuffer sb = new StringBuffer();
        int curPos = 0;

        int _pos = name.indexOf('_', curPos) + 1;

        while(_pos != 0) {

            sb.append(swapcase(name.substring(curPos, _pos - 1)));
            curPos = _pos;

            _pos = name.indexOf('_', curPos) + 1;
        }

        sb.append(swapcase(name.substring(curPos)));

        return sb.toString();
    }

    /**
     * Dog -> dog
     * whatTheF -> WhatTheF
     */
    public static String swapcase(String word) {
        if(Character.isUpperCase(word.charAt(0)))
            return Character.toLowerCase(word.charAt(0)) + word.substring(1);
        else
            return Character.toUpperCase(word.charAt(0)) + word.substring(1);
    }
}
